from MIFAREDriver import MIFAREReader, MIFAREException
from serial import Serial
from LDAPConnector import get_uid, set_card_id

class MIFAREClient:
    def __init__(self):
        self.port = Serial('/dev/ttyS0', baudrate = 19200)
        self.reader = MIFAREReader(self.port)
        self.reader.set_led(red = False, green = True)
        self.reader.beep(100)
    
    def get_card_id(self):
        self.reader.set_led(red = True, green = False)
        try:
            card_id, capacity = self.reader.select_card()
        except MIFAREException:
            self.reader.set_led(red = False, green = True)
            return None
        else:
            self.reader.set_led(red = False, green = True)
            self.reader.beep(100)
            return card_id
    
    def get_card_uid(self):
		card_id = self.get_card_id()
		if card_id == None:
			return None
		else:
			return get_uid(card_id)
    
    def add_card(self, uid):
        self.reader.set_led(red = True, green = False)
        for attempt in range(5):
            self.reader.beep(50)
            try:
                card_id, capacity = self.reader.select_card()
            except MIFAREException:
                pass
            else:
                set_card_id(uid, card_id)
                self.reader.set_led(red = False, green = True)
                return True
        self.reader.set_led(red = False, green = True)
        return False
